diff -crN nakedmudv1.4/src/gameloop.c nakedmudv1.5/src/gameloop.c
*** nakedmudv1.4/src/gameloop.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/gameloop.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 17,27 ****
  #include "inform.h"
  #include "text_editor.h"
  #include "log.h"
- #include "races.h"
  #include "action.h"
  #include "event.h"
  #include "auxiliary.h"
  #include "storage.h"
  
  
  // optional modules
--- 17,28 ----
  #include "inform.h"
  #include "text_editor.h"
  #include "log.h"
  #include "action.h"
  #include "event.h"
  #include "auxiliary.h"
  #include "storage.h"
+ #include "races.h"
+ #include "body.h"
  
  
  // optional modules
***************
*** 48,54 ****
  #endif
  
  
- 
  /* mccp support */
  const unsigned char do_echo         [] = { IAC, WONT, TELOPT_ECHO,      '\0' };
  const unsigned char dont_echo       [] = { IAC, WILL, TELOPT_ECHO,      '\0' };
--- 49,54 ----
***************
*** 146,151 ****
--- 146,155 ----
    log_string("Preparing auxiliary data for usage.");
    init_auxiliaries();
  
+   /* prepare races and bodies for use */
+   log_string("Initializing races and default bodies.");
+   init_races();
+ 
    /* initialize our command table */
    log_string("Initializing command table.");
    init_commands();
***************
*** 179,185 ****
    init_time();
  #endif
  
-   /* initialize faculties */
  #ifdef MODULE_CHAR_VARS
    log_string("Initializing character variables.");
    init_char_vars();
--- 183,188 ----
***************
*** 237,249 ****
  }
  
  
- int num_updates = 0;
  //
  // let all of our actions and events know that time has gone by.
  // Also, give a chance of doing some resetting in the game.
  //
  void update_handler()
  {
    // increment the number of updates we've done
    num_updates++;
  
--- 240,252 ----
  }
  
  
  //
  // let all of our actions and events know that time has gone by.
  // Also, give a chance of doing some resetting in the game.
  //
  void update_handler()
  {
+   static int num_updates = 0;
    // increment the number of updates we've done
    num_updates++;
  
***************
*** 255,261 ****
    // we don't want to be on the same schedule as
    // everything else, that updates every PULSES_PER_SECOND. 
    // We want to be on a schedule that updates every minute or so.
!   if(num_updates % PULSES_PER_SECOND * 60 == 0)
      worldPulse(gameworld);
  }
  
--- 258,264 ----
    // we don't want to be on the same schedule as
    // everything else, that updates every PULSES_PER_SECOND. 
    // We want to be on a schedule that updates every minute or so.
!   if((num_updates % (1 MINUTE)) == 0)
      worldPulse(gameworld);
  }
  
***************
*** 343,349 ****
  	case STATE_VERIFY_PASSWORD:
  	case STATE_ASK_PASSWORD:
  	case STATE_ASK_SEX:
! 	case STATE_ASK_RACE:
  	  handle_new_connections(dsock, dsock->next_command);
  	  break;
  	case STATE_PLAYING:
--- 346,352 ----
  	case STATE_VERIFY_PASSWORD:
  	case STATE_ASK_PASSWORD:
  	case STATE_ASK_SEX:
!    	case STATE_ASK_RACE:
  	  handle_new_connections(dsock, dsock->next_command);
  	  break;
  	case STATE_PLAYING:
***************
*** 547,561 ****
  }
  
  void list_races(SOCKET_DATA *sock) {
-   int i;
    send_to_socket(sock, "Available races are:\r\n");
!   for(i = 0; i < NUM_RACES; i++) {
!     if(!raceIsForPC(i))
!       continue;
!     send_to_socket(sock, "%s%s", 
! 		   (i == 0 ? "" : ", "),
! 		   raceGetName(i));
!   }
    send_to_socket(sock, "\r\n\r\nPlease enter your choice: ");
  }
  
--- 550,557 ----
  }
  
  void list_races(SOCKET_DATA *sock) {
    send_to_socket(sock, "Available races are:\r\n");
!   send_to_socket(sock, "%s", raceGetList(TRUE));
    send_to_socket(sock, "\r\n\r\nPlease enter your choice: ");
  }
  
***************
*** 563,576 ****
  // Ask for the character's race. Called each time a character is created
  //
  void state_ask_race(SOCKET_DATA *dsock, char *arg) {
!   int racenum = raceGetNum(arg);
! 
!   if(racenum == RACE_NONE || racenum >= NUM_RACES || !raceIsForPC(racenum)) {
      send_to_socket(dsock, "Invalid race! Please try again: ");
      return;
!   }
    else {
!     charSetRace(dsock->player, racenum);
      charResetBody(dsock->player);
    }
  
--- 559,570 ----
  // Ask for the character's race. Called each time a character is created
  //
  void state_ask_race(SOCKET_DATA *dsock, char *arg) {
!   if(!arg || !*arg || !raceIsForPC(arg)) {
      send_to_socket(dsock, "Invalid race! Please try again: ");
      return;
!   }    
    else {
!     charSetRace(dsock->player, arg);
      charResetBody(dsock->player);
    }
  
***************
*** 595,604 ****
    char_to_room(dsock->player, worldGetRoom(gameworld, START_ROOM));
    look_at_room(dsock->player, charGetRoom(dsock->player));
  
  #ifdef MODULE_SCRIPTS
    // check enterance scripts
!   try_enterance_script(dsock->player, charGetRoom(dsock->player),
! 		       NULL, NULL);
  #endif
  }
  
--- 589,600 ----
    char_to_room(dsock->player, worldGetRoom(gameworld, START_ROOM));
    look_at_room(dsock->player, charGetRoom(dsock->player));
  
+   /* and save him */
+   save_player(dsock->player);
+ 
  #ifdef MODULE_SCRIPTS
    // check enterance scripts
!   try_enterance_script(dsock->player, charGetRoom(dsock->player), NULL);
  #endif
  }
  
***************
*** 687,694 ****
  
  #ifdef MODULE_SCRIPTS
  	// check enterance scripts
! 	try_enterance_script(p_new, charGetRoom(p_new),
! 			     NULL, NULL);
  #endif
        }
        else {
--- 683,689 ----
  
  #ifdef MODULE_SCRIPTS
  	// check enterance scripts
! 	try_enterance_script(p_new, charGetRoom(p_new), NULL);
  #endif
        }
        else {
diff -crN nakedmudv1.4/src/.gdb_history nakedmudv1.5/src/.gdb_history
*** nakedmudv1.4/src/.gdb_history	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/.gdb_history	2010-11-01 15:54:17.000000000 -0500
***************
*** 1,47 ****
- down
- up
- up
- up
- print room->auxiliary_data
- down
- print line
- print data
- info local
- bt
- quit
- run
- quit
- run
- bt
- print line
- quit
- run
- print line
- quit
- run
- bt
- quit
- run
- bt
- down
- up
- up
- up
- up
- print world
- bt
- quit
- run
- quit
- run
- bt
- quit
- run
- quit
- run
- quit
- run
- quit
  run
  bt
  quit
--- 1,3 ----
***************
*** 254,256 ****
--- 210,256 ----
  quit
  run
  quit
+ run
+ bt
+ quit
+ run
+ quit
+ run
+ bt
+ quit
+ run
+ bt
+ quit
+ run 4000
+ bt
+ quit
+ run
+ bt
+ up
+ up
+ print data
+ print data->curr_path
+ print listSize(data->curr_path)
+ quit
+ run
+ quit
+ run
+ bt
+ quit
+ run
+ print i
+ print j
+ print map->rooms[i]
+ print map->rooms[j]
+ print map->rooms
+ quit
+ run
+ quit
+ run 4000
+ bt
+ quit
+ run
+ quit
+ run
+ bt
+ quit
diff -crN nakedmudv1.4/src/handler.c nakedmudv1.5/src/handler.c
*** nakedmudv1.4/src/handler.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/handler.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 234,245 ****
    // object give
    try_scripts(SCRIPT_TYPE_GIVE,
  	      obj, SCRIPTOR_OBJ,
! 	      ch, obj, charGetRoom(ch), NULL, NULL, NULL, 0);
    
    // char receive
    try_scripts(SCRIPT_TYPE_GIVE,
  	      recv, SCRIPTOR_CHAR,
! 	      ch, obj, charGetRoom(ch), NULL, NULL, NULL, 0);
  #endif
  }
  
--- 234,245 ----
    // object give
    try_scripts(SCRIPT_TYPE_GIVE,
  	      obj, SCRIPTOR_OBJ,
! 	      ch, obj, charGetRoom(ch), NULL, NULL, 0);
    
    // char receive
    try_scripts(SCRIPT_TYPE_GIVE,
  	      recv, SCRIPTOR_CHAR,
! 	      ch, obj, charGetRoom(ch), NULL, NULL, 0);
  #endif
  }
  
***************
*** 253,262 ****
    // check for triggers
    try_scripts(SCRIPT_TYPE_DROP,
  	      charGetRoom(ch), SCRIPTOR_ROOM,
! 	      ch, obj, charGetRoom(ch), NULL, NULL, NULL, 0);
    try_scripts(SCRIPT_TYPE_DROP,
  	      obj, SCRIPTOR_OBJ,
! 	      ch, obj, charGetRoom(ch), NULL, NULL, NULL, 0);
  #endif
  }
  
--- 253,262 ----
    // check for triggers
    try_scripts(SCRIPT_TYPE_DROP,
  	      charGetRoom(ch), SCRIPTOR_ROOM,
! 	      ch, obj, charGetRoom(ch), NULL, NULL, 0);
    try_scripts(SCRIPT_TYPE_DROP,
  	      obj, SCRIPTOR_OBJ,
! 	      ch, obj, charGetRoom(ch), NULL, NULL, 0);
  #endif
  }
  
***************
*** 828,834 ****
  
      // now special exits
      int num_exits = 0;
!     char **ex_names = roomGetExitNames(charGetRoom(looker), &num_exits);
      for(ex_i = 0; ex_i < num_exits; ex_i++) {
        exit = roomGetExitSpecial(charGetRoom(looker), ex_names[ex_i]);
        if(!exit)
--- 828,834 ----
  
      // now special exits
      int num_exits = 0;
!     const char **ex_names = roomGetExitNames(charGetRoom(looker), &num_exits);
      for(ex_i = 0; ex_i < num_exits; ex_i++) {
        exit = roomGetExitSpecial(charGetRoom(looker), ex_names[ex_i]);
        if(!exit)
***************
*** 854,861 ****
        exit = NULL;
  
      // clean up our mess
-     for(ex_i = 0; ex_i < num_exits; ex_i++)
-       free(ex_names[ex_i]);
      free(ex_names);
  
      // we got one
--- 854,859 ----
diff -crN nakedmudv1.4/src/help/help.c nakedmudv1.5/src/help/help.c
*** nakedmudv1.4/src/help/help.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/help/help.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,539 ----
+ //*****************************************************************************
+ //
+ // help.c
+ //
+ // This helpfile system has been set up to be amenable to allowing players to
+ // edit helpfiles without having to worry about malicious users. 
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../storage.h"
+ #include "../character.h"
+ #include "../socket.h"
+ 
+ #include "help.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // local variables, data structures, and functions
+ //
+ //*****************************************************************************
+ 
+ // the file we keep all of our help in
+ #define HELP_FILE          "../lib/misc/help"
+ 
+ // how many buckets are in our help table
+ #define HELP_TABLE_BUCKETS             27 // 26 for letters, 1 for non-alphas
+ 
+ // the table we store all of our helpfiles in
+ LIST *help_table[HELP_TABLE_BUCKETS];
+ 
+ typedef struct help_data {
+   char *keywords;   // words that bring up this helpfile
+   char *info;       // the information in the helpfile
+   char *editor;     // who edited the helpfile?
+   char *timestamp;  // when was it last edited?
+   LIST *backups;    // a chronologically sorted list of backup helps
+ } HELP_DATA;
+ 
+ 
+ HELP_DATA *newHelp(const char *editor, const char *timestamp,
+ 		   const char *keywords, const char *info) {
+   HELP_DATA *data = malloc(sizeof(HELP_DATA));
+   data->keywords  = strdup(keywords  ? keywords  : "");
+   data->editor    = strdup(editor    ? editor    : "");
+   data->info      = strdup(info      ? info      : "");
+   data->timestamp = strdup(timestamp ? timestamp : "");
+   data->backups   = newList();
+   return data;
+ }
+ 
+ void deleteHelp(HELP_DATA *data) {
+   deleteListWith(data->backups, deleteHelp);
+   if(data->keywords)  free(data->keywords);
+   if(data->editor)    free(data->editor);
+   if(data->timestamp) free(data->timestamp);
+   if(data->info)      free(data->info);
+   free(data);
+ }
+ 
+ HELP_DATA *helpRead(STORAGE_SET *set) {
+   HELP_DATA *data = newHelp(read_string(set, "editor"),
+ 			    read_string(set, "timestamp"),
+ 			    read_string(set, "keywords"),
+ 			    read_string(set, "info"));
+   deleteList(data->backups);
+   data->backups = gen_read_list(read_list(set, "backups"), helpRead);
+   return data;
+ }
+ 
+ STORAGE_SET *helpStore(HELP_DATA *help) {
+   STORAGE_SET *set = new_storage_set();
+   store_string(set, "keywords",  help->keywords);
+   store_string(set, "editor",    help->editor);
+   store_string(set, "timestamp", help->timestamp);
+   store_string(set, "info",      help->info);
+   store_list  (set, "backups",   gen_store_list(help->backups, helpStore));
+   return set;
+ }
+ 
+ 
+ //
+ // HELP_DATA holds all of the information about a helpfile, but HELP_ENTRY
+ // is a key/value pair used for storing helpfiles in the help table.
+ //
+ typedef struct help_entry {
+   char   *keyword;
+   HELP_DATA *help;
+ } HELP_ENTRY;
+ 
+ HELP_ENTRY *newHelpEntry(const char *keyword, HELP_DATA *data) {
+   HELP_ENTRY *entry = malloc(sizeof(HELP_ENTRY));
+   entry->keyword = strdup(keyword ? keyword : NULL);
+   entry->help    = data;
+   return entry;
+ }
+ 
+ void deleteHelpEntry(HELP_ENTRY *entry) {
+   if(entry->keyword) free(entry->keyword);
+   free(entry);
+ }
+ 
+ int hentrycmp(HELP_ENTRY *entry1, HELP_ENTRY *entry2) {
+   return strcasecmp(entry1->keyword, entry2->keyword);
+ }
+ 
+ int is_help_entry(const char *help, HELP_ENTRY *entry) {
+   return strcasecmp(help, entry->keyword);
+ }
+ 
+ int is_help_abbrev(const char *help, HELP_ENTRY *entry) {
+   return strncasecmp(help, entry->keyword, strlen(help));
+ }
+ 
+ 
+ //
+ // return the bucket that the specified helpfile belongs to
+ //
+ int helpbucket(const char *help) {
+   if(isalpha(*help))
+     return (tolower(*help) - 'a');
+   else
+     return HELP_TABLE_BUCKETS-1;
+ }
+ 
+ 
+ //
+ // save all of the helpfiles
+ //
+ void save_help() {
+   STORAGE_SET      *set = new_storage_set();
+   LIST       *help_list = newList();
+ 
+   // iterate across the table and save all the unique helpfiles
+   int i;
+   for(i = 0; i < HELP_TABLE_BUCKETS; i++) {
+     LIST_ITERATOR *row_i = newListIterator(help_table[i]);
+     HELP_ENTRY    *entry = NULL;
+     ITERATE_LIST(entry, row_i)
+       listPut(help_list, entry->help);
+     deleteListIterator(row_i);
+   }
+ 
+   store_list(set, "helpfiles", gen_store_list(help_list, helpStore));
+   deleteList(help_list);
+ 
+   // write the set
+   storage_write(set, HELP_FILE);
+   
+   // close the set
+   storage_close(set);
+ }
+ 
+ 
+ //
+ // add a helpfile to the help table. Assocciate all of its keywords with it
+ //
+ void add_help(HELP_DATA *help) {
+   int num_keywords = 0;
+   char  **keywords = parse_keywords(help->keywords, &num_keywords);
+   int i;
+   for(i = 0; i < num_keywords; i++) {
+     LIST *row = help_table[helpbucket(keywords[i])];
+     HELP_ENTRY *new_entry = newHelpEntry(keywords[i], help);
+     HELP_ENTRY *old_entry = NULL;
+     // make sure we're not already in the help table
+     if((old_entry = listRemoveWith(row, new_entry, hentrycmp)) != NULL)
+       deleteHelpEntry(old_entry);
+     listPutWith(row, new_entry, hentrycmp);
+     free(keywords[i]);
+   }
+   free(keywords);
+ }
+ 
+ 
+ //
+ // Returns the datastructure for the helpfile
+ //
+ HELP_DATA *get_help_data(const char *keyword, bool abbrev_ok) {
+   HELP_ENTRY *entry = listGetWith(help_table[helpbucket(keyword)], keyword, 
+ 				  (abbrev_ok ? is_help_abbrev : is_help_entry));
+   return (entry ? entry->help : NULL);
+ }
+ 
+ 
+ //
+ // remove a helpfile from the help table
+ //
+ HELP_DATA *remove_help(const char *keyword) {
+   HELP_ENTRY *entry = listRemoveWith(help_table[helpbucket(keyword)], keyword, 
+ 				     is_help_entry);
+   HELP_DATA *help = (entry ? entry->help : NULL);
+   if(entry) deleteHelpEntry(entry);
+   return help;
+ }
+ 
+ 
+ //
+ // return a list of matches for the specified help keyword. If we find an
+ // exact match, only that match will be contained within the list.
+ // List must be deleted after use.
+ //
+ LIST *help_matches(const char *keyword) {
+   int bucket  = helpbucket(keyword);
+   int key_len = strlen(keyword);
+   LIST_ITERATOR *buck_i = newListIterator(help_table[bucket]);
+   HELP_ENTRY     *entry = NULL;
+   LIST         *matches = newList();
+ 
+   ITERATE_LIST(entry, buck_i) {
+     // exact match
+     if(!strcasecmp(keyword, entry->keyword)) {
+       while(listSize(matches) > 0) listPop(matches);
+       listPut(matches, entry);
+       break;
+     }
+     else if(!strncasecmp(keyword, entry->keyword, key_len))
+       listQueue(matches, entry);
+   }
+   deleteListIterator(buck_i);
+   return matches;
+ }
+ 
+ 
+ //
+ // Show the contents of a helpfile to the character. If no argument is
+ // supplied, list all of the helpfiles. If we try to get info on a help
+ // that does not exist, list near-matches.
+ //
+ // usage:
+ //   help <topic>
+ //
+ COMMAND(cmd_help) {
+   static char buf[MAX_BUFFER];
+   
+   // no argument. Show a list of all our help topics
+   if(!arg || !*arg) {
+     int count, i, buf_i = 0;
+     buf_i = snprintf(buf, MAX_BUFFER, 
+ 		     "Help is available on the following topics:\r\n");
+     for(i = 0, count = 0; i < HELP_TABLE_BUCKETS; i++) {
+       LIST_ITERATOR *buck_i = newListIterator(help_table[i]);
+       HELP_ENTRY     *entry = NULL;
+       ITERATE_LIST(entry, buck_i) {
+ 	buf_i += snprintf(buf+buf_i, MAX_BUFFER-buf_i, "%-20s", entry->keyword);
+ 	count++;
+ 	// only 4 entries per row
+ 	if((count % 4) == 0) 
+ 	  buf_i += snprintf(buf+buf_i, MAX_BUFFER-buf_i, "\r\n");
+       }
+       deleteListIterator(buck_i);
+     }
+ 
+     // make sure we add a newline to the end
+     if((count % 4) != 0)
+       buf_i += snprintf(buf+buf_i, MAX_BUFFER-buf_i, "\r\n");
+ 
+     // send this to the character
+     if(charGetSocket(ch))
+       page_string(charGetSocket(ch), buf);
+   }
+ 
+ 
+   // pull out the helpfile
+   else {
+     // because we replace underscores with spaces in hlink,
+     // we should do the same thing here for consistancy's sake
+     char *ptr;
+     for(ptr = arg; *ptr; ptr++)
+       if(*ptr == '_') *ptr = ' ';
+ 
+     LIST *matches = help_matches(arg);
+     HELP_ENTRY *entry = NULL;
+     // no matches found
+     if(listSize(matches) == 0)
+       send_to_char(ch, "No help exists on that topic.\r\n");
+     // one match found
+     else if(listSize(matches) == 1) {
+       if(charGetSocket(ch)) {
+ 	entry = listPop(matches);
+ 	// the character has a socket... let's page the helpfile to him
+ 	if(charGetSocket(ch)) {
+ 	  char header[128]; // +2 for \r\n, +1 for \0
+ 	  center_string(header, entry->keyword, 80, 128, TRUE);
+ 	  sprintf(buf, "%s{wBy: %-36s%40s\r\n\r\n{n%s",
+ 		  header, entry->help->editor, entry->help->timestamp,
+ 		  entry->help->info);
+ 	  page_string(charGetSocket(ch), buf);
+ 	}
+       }
+     }
+ 
+     // more than one match found. Tell person to narrow search
+     else {
+       send_to_char(ch, "More than one entry matched your query: \r\n");
+       LIST_ITERATOR *match_i = newListIterator(matches);
+       ITERATE_LIST(entry, match_i)
+ 	send_to_char(ch, "{c%s ", entry->keyword);
+       deleteListIterator(match_i);
+       send_to_char(ch, "\r\n");
+     }
+     
+     // delete the list of matches we found
+     deleteList(matches);
+   }
+ }
+ 
+ 
+ //
+ // same as cmd_write, but loads the contents of the helpfile into the buffer
+ //
+ COMMAND(cmd_hedit) {
+   if(!arg || !*arg) {
+     send_to_char(ch, "Which helpfile are you trying to edit?\r\n");
+     return;
+   }
+   if(!charGetSocket(ch)) {
+     send_to_char(ch, "You must have a socket attached to use hedit.\r\n");
+     return;
+   }
+ 
+   // because we replace underscores with spaces in hlink,
+   // we should do the same thing here for consistancy's sake
+   char *ptr;
+   for(ptr = arg; *ptr; ptr++)
+     if(*ptr == '_') *ptr = ' ';
+ 
+   HELP_DATA *data = get_help_data(arg, FALSE);
+   start_notepad(charGetSocket(ch), (data ? data->info : ""), 
+ 		MAX_BUFFER, EDITOR_MODE_NORMAL);
+ }
+ 
+ 
+ //
+ // Edit the contents of a helpfile
+ //
+ COMMAND(cmd_hupdate) {
+   if(!arg || !*arg) {
+     send_to_char(ch, "Which helpfile were you trying to update?\r\n");
+     return;
+   }
+   if(!charGetSocket(ch) || !charGetSocket(ch)->notepad || 
+      !*charGetSocket(ch)->notepad) {
+     send_to_char(ch, "You have nothing in your notepad! Try writing something.\r\n");
+     return;
+   }
+ 
+   // because we replace underscores with spaces in hlink,
+   // we should do the same thing here for consistancy's sake
+   char *ptr;
+   for(ptr = arg; *ptr; ptr++)
+     if(*ptr == '_') *ptr = ' ';
+ 
+   update_help(charGetName(ch), arg, charGetSocket(ch)->notepad);
+ }
+ 
+ 
+ //
+ // Link a keyword to an already-existing helpfile. underscores must be
+ // used instead of spaces.
+ //   usage:
+ //     hlink [new_topic] [old_topic]
+ //
+ COMMAND(cmd_hlink) {
+   char new_help[SMALL_BUFFER];
+ 
+   if(!arg || !*arg) {
+     send_to_char(ch, "Link which helpfile to which?\r\n");
+     return;
+   }
+ 
+   arg = one_arg(arg, new_help);
+ 
+   if(!*new_help || !*arg) {
+     send_to_char(ch, "You must provide a new keyword and an old keyword "
+ 		 "to link it to.\r\n");
+     return;
+   }
+ 
+   // kill all of the underscores, and put spaces in instead
+   char *ptr;
+   for(ptr = new_help; *ptr; ptr++)
+     if(*ptr == '_') *ptr = ' ';
+   for(ptr = arg; *ptr; ptr++)
+     if(*ptr == '_') *ptr = ' ';
+ 
+   // find the help we're trying to link to
+   HELP_DATA *help = get_help_data(arg, FALSE);
+ 
+   if(help == NULL) {
+     send_to_char(ch, "No help exists for %s.\r\n", arg);
+     return;
+   }
+ 
+ 
+   // perform the link
+   link_help(new_help, arg);
+   send_to_char(ch, "%s linked to %s.\r\n", new_help, arg);
+ }
+ 
+ 
+ //
+ // Unlink a keyword from its assocciated helpfile. 
+ //   usage:
+ //     hunlink [topic]
+ //
+ COMMAND(cmd_hunlink) {
+   if(!arg || !*arg) {
+     send_to_char(ch, "Unlink which helpfile?\r\n");
+     return;
+   }
+ 
+   // because we replace underscores with spaces in hlink,
+   // we should do the same thing here for consistancy's sake
+   char *ptr;
+   for(ptr = arg; *ptr; ptr++)
+     if(*ptr == '_') *ptr = ' ';
+ 
+   // find the social we're trying to link to
+   HELP_DATA *help = get_help_data(arg, FALSE);
+ 
+   if(help == NULL) {
+     send_to_char(ch, "No help exists for %s.\r\n", arg);
+     return;
+   }
+ 
+   // perform the unlinking
+   unlink_help(arg);
+   send_to_char(ch, "The %s helpfile was unlinked.\r\n", arg);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // implementation of help.h
+ //
+ //*****************************************************************************
+ void init_help() {
+   // init all of our buckets
+   int i;
+   for(i = 0; i < HELP_TABLE_BUCKETS; i++)
+     help_table[i] = newList();
+ 
+   // add all of our commands
+   add_cmd("help", NULL, cmd_help, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_PLAYER, FALSE, FALSE);
+   add_cmd("hlink", NULL, cmd_hlink, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_ADMIN, FALSE, FALSE);
+   add_cmd("hunlink", NULL, cmd_hunlink, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_ADMIN, FALSE, FALSE);
+   add_cmd("hupdate", NULL, cmd_hupdate, 0, POS_SITTING, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, TRUE);
+   add_cmd("hedit", NULL, cmd_hedit, 0, POS_SITTING, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, TRUE);
+ 
+   // read in all of our helps
+   STORAGE_SET       *set = storage_read(HELP_FILE);
+   STORAGE_SET_LIST *list = read_list(set, "helpfiles");
+   STORAGE_SET     *entry = NULL;
+ 
+   // parse all of the helpfiles
+   while( (entry = storage_list_next(list)) != NULL)
+     add_help(helpRead(entry));
+ 
+   storage_close(set);
+ }
+ 
+ const char *get_help(const char *keyword) {
+   HELP_DATA *data = get_help_data(keyword, FALSE);
+   return(data ? data->info : NULL);
+ }
+ 
+ 
+ void update_help(const char *editor, const char *keyword, const char *info) {
+   HELP_DATA *data = get_help_data(keyword, FALSE);
+ 
+   if(data != NULL) {
+     HELP_DATA *help_old = newHelp(data->editor, data->timestamp, data->keywords,
+ 				  data->info);
+     if(data->editor)    free(data->editor);
+     if(data->timestamp) free(data->timestamp);
+     if(data->info)      free(data->info);
+     
+     data->editor      = strdup(editor ? editor : "");
+     data->info        = strdup(info   ? info   : "");
+     data->timestamp   = strdup(get_time());
+ 
+     listPut(data->backups, help_old);
+   }
+   else
+     add_help(newHelp(editor, get_time(), keyword, info));
+ 
+   save_help();
+ }
+ 
+ 
+ void unlink_help(const char *keyword) {
+   // remove the helpfile
+   HELP_DATA *data = remove_help(keyword);
+ 
+   // unlink the helpfile
+   if(data != NULL) {
+     remove_keyword(data->keywords, keyword);
+ 
+     // if no links are left, delete the helpfile
+     if(!*data->keywords)
+       deleteHelp(data);
+     
+     // save our changes
+     save_help();
+   }
+ }
+ 
+ 
+ void link_help(const char *keyword, const char *old_word) {
+   // check for the old keyword
+   HELP_DATA *data = get_help_data(old_word, FALSE);
+ 
+   // link the new keyword to the old one
+   if(data != NULL) {
+     // first, remove the current new_keyword help, if it exists
+     unlink_help(keyword);
+ 
+     // add the new keyword to the help
+     add_keyword(&(data->keywords), keyword);
+ 
+     // add the new command to the help table
+     LIST *row = help_table[helpbucket(keyword)];
+     HELP_ENTRY *new_entry = newHelpEntry(keyword, data);
+     listPutWith(row, new_entry, hentrycmp);
+ 
+     // save our changes
+     save_help();
+   }
+ }
diff -crN nakedmudv1.4/src/help/help.h nakedmudv1.5/src/help/help.h
*** nakedmudv1.4/src/help/help.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/help/help.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,51 ----
+ #ifndef __HELP_H
+ #define __HELP_H
+ //*****************************************************************************
+ //
+ // help.h
+ //
+ // This helpfile system has been set up to be amenable to allowing players to
+ // edit helpfiles without having to worry about malicious users. 
+ //
+ //*****************************************************************************
+ 
+ //
+ // This must be put at the top of mud.h so the rest of the MUD knows that
+ // we've got the help module installed
+ // #define MODULE_HELP
+ //
+ 
+ 
+ //
+ // prepare helpfiles for use
+ //
+ void init_help();
+ 
+ 
+ //
+ // Make changes to the content of the helpfile. The old info is backed up.
+ // To protect against malicious changes. update_help can be used to create
+ // new helpfiles as well.
+ //
+ void update_help(const char *editor, const char *keyword, const char *info);
+ 
+ 
+ //
+ // Get the content of the helpfile. Return NULL if none exists.
+ //
+ const char *get_help(const char *keyword);
+ 
+ 
+ //
+ // unlink a keyword from the help info. If no more links are left to the
+ // helpfile, the helpfile is deleted.
+ //
+ void unlink_help(const char *keyword);
+ 
+ 
+ //
+ // link a new keyword to a helpfile
+ //
+ void link_help(const char *keyword, const char *old_word);
+ 
+ #endif // __HELP_H
diff -crN nakedmudv1.4/src/help/module.mk nakedmudv1.5/src/help/module.mk
*** nakedmudv1.4/src/help/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/help/module.mk	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ # the source files we need to compile
+ SRC += help/help.c
